/**********************************************
	range_migration.c

	s-s_c = (f-f_Dc)/f_R

	delta_R= -lambda/2*f_Dc(f-f_Dc)/f_R
		-lambda/4/f_R(s-s_c)^2

by Dr. Hoonyol Lee
Dept. of Geophysics
Kangwon National University
start: 22 May 2004
***********************************************/

void range_migration()
{
 	int i, j, ix, jm;  /* jm = 'j migrated' */
	int idelta_pixel;
	double delta_R, delta_f, delta_pixel;
	double f; /*azimuth frequency*/
	double delta_R_max, delta_R_min;
	int idelta_pixel_max, idelta_pixel_min;
	double *buf;	 

	printf(" range_migration:\n");

	buf = dvector(nrange_fft*2);

	delta_f = pulse_repetition_frequency/nazimuth_fft;

	/* first half */	
	delta_R_max=0.;
	idelta_pixel_max=0;
	delta_R_min=1.e8;
	idelta_pixel_min=100000000;
	for(i=0; i<nazimuth_fft/2; i++)
	{
	   f= i*delta_f;
	   ix=i*nrange_fft*2;
	   delta_R= -1.*wavelength*Doppler_centroid/2.*
		(f-Doppler_centroid)/Doppler_rate -
		wavelength/4.*
		(f-Doppler_centroid)*(f-Doppler_centroid)/Doppler_rate;
	   delta_pixel = delta_R/range_pixel_size;
	   idelta_pixel = (int)(delta_pixel+0.5);

	   if(delta_R>delta_R_max) delta_R_max = delta_R;
	   if(delta_R<delta_R_min) delta_R_min = delta_R;
	   if(idelta_pixel>idelta_pixel_max) idelta_pixel_max = idelta_pixel;
	   if(idelta_pixel<idelta_pixel_min) idelta_pixel_min = idelta_pixel;

	   /*printf("%d %lf %lf %lf\n", i, f, delta_R, delta_pixel);
	*/
	   for(j=0; j<nrange_fft; j++)
	   {
		jm=j+idelta_pixel;
		if(jm>=0 && jm<nrange_fft)	
		{
		   buf[2*j] = data[ix+2*jm];
		   buf[2*j+1] = data[ix+2*jm+1];
	  	} 
	   }
	   for(j=0; j<nrange_fft*2; j++) data[ix+j]=buf[j];
		
	}

	/* next half */	
	for(i=nazimuth_fft/2; i<nazimuth_fft; i++)
	{
	   f= (i-nazimuth_fft)*delta_f;
	   ix=i*nrange_fft*2;
	   delta_R= -1.*wavelength*Doppler_centroid/2.*
		(f-Doppler_centroid)/Doppler_rate -
		wavelength/4.*
		(f-Doppler_centroid)*(f-Doppler_centroid)/Doppler_rate;
	   delta_pixel = delta_R/range_pixel_size;
	   idelta_pixel = (int)(delta_pixel+0.5);

	   if(delta_R > delta_R_max) delta_R_max = delta_R;
	   if(delta_R < delta_R_min) delta_R_min = delta_R;
	   if(idelta_pixel > idelta_pixel_max) idelta_pixel_max = idelta_pixel;
	   if(idelta_pixel < idelta_pixel_min) idelta_pixel_min = idelta_pixel;

	   for(j=0; j<nrange_fft; j++)
	   {
		jm=j+idelta_pixel;
		if(jm>=0 && jm<nrange_fft)	
		{
		   buf[2*j] = data[ix+2*jm];
		   buf[2*j+1] = data[ix+2*jm+1];
	  	} 
	   }
	   for(j=0; j<nrange_fft*2; j++) data[ix+j]=buf[j];

	}
	printf("   maximum migration= %lf m, %d pixels.\n", delta_R_max, idelta_pixel_max);
	printf("   minimum migration= %lf m, %d pixels.\n", delta_R_min, idelta_pixel_min);

}


